import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import java.io.*;


Convertisseur convertisseur;
PImage aConvertir;
byte [] chaineVdtConvertie;
int[][] pixMin;

boolean nouvelleImage = true;

void setup() {
  size(800, 600);

  convertisseur = new Convertisseur();
  aConvertir = loadImage("data/vache.jpg"); // par defaut
  chaineVdtConvertie = convertisseur.convertir(aConvertir);
  
  loadJpg();
}

void draw() {
  if (nouvelleImage) {
    background(0);
    //aConvertir.resize(80, 72);
    int wImg = width*2/3;
    int hImg = wImg*3/4;
    //image(aConvertir, width/6, 40, wImg, hImg);
    pixMin = convertisseur.pixAff(aConvertir);
    int scale = 5;
    noStroke();
    for (int y=0; y<72; y++) {
      for (int x=0; x<80; x++) {
        fill(pixMin[x][y]);
        rect(width/6+scale*x,40+scale*y,scale,scale);
      }
    }
    int n = chaineVdtConvertie.length;
    fill(255);
    textSize(12);
    for (int i=0; i<n; i++) {
      int x = 10 + (i%39)*20;
      int y = hImg + 60 + (i/39)*20;
      text(hex(chaineVdtConvertie[i]), x, y);
    }
    fill(255, 0, 0);
    textSize(18);
    text("Taper S pour créer fichier vdt    ---- Taper C pour copier chaine vdt en hexadécimal", 10, 18);
    text("Taper O pour ouvrir une nouvelle image jpg", 10, 36);
    nouvelleImage = false;
  }
}

void loadJpg() {
  selectInput("Choisir l'image jpg à charger", "jpgOuvrir");
}

void jpgOuvrir(File selection) {
  if (selection == null) {
    println("Annulation ouvrir fichier");
  } else {
    println("image selectionnee " + selection.getAbsolutePath());
    aConvertir = loadImage(selection.getAbsolutePath());
    chaineVdtConvertie = convertisseur.convertir(aConvertir);
    nouvelleImage = true;
  }
}

void sauvTex() {
  selectOutput("Enregistrer le fichier sous", "fichierSauver");
}

void fichierSauver(File selection) {
  if (selection == null) {
    println("Annulation enregistrement");
  } else {
    println("fichier destination =  " + selection.getAbsolutePath());
    int n = chaineVdtConvertie.length;
    byte [] chaineVdtASauver = new byte[n+2];
    chaineVdtASauver[0] = 0x0C;
    chaineVdtASauver[1] = 0x0E;
    for (int i = 0; i < n; i++) {
      chaineVdtASauver[i+2] = chaineVdtConvertie[i];
    }
    saveBytes(selection.getAbsolutePath(), chaineVdtASauver);
  }
}

void keyPressed() {
  if (key == 's' || key == 'S') {
    sauvTex();
  }
  if (key == 'o' || key == 'O') {
    loadJpg();
  }
  if (key == 'c' || key == 'C') {
    String selection = "0C 0E ";
    int n = chaineVdtConvertie.length;
    for (int i=0; i<n; i++) {
      selection += hex(chaineVdtConvertie[i]) + " ";
    } 
    StringSelection data = new StringSelection(selection);
    Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    clipboard.setContents(data, data);
    println("vdt copiées");
    background(0, 255, 0);
    nouvelleImage = true;
  }
}
